/*###########################################################################
#                                                                           #
#   		 		         ݒ									#
#                                                                           #
###########################################################################*/
#define __MENU004_C__
#include "project.h"

#define DATE_X 1
#define DATE_Y 18

#define TIME_X 62
#define TIME_Y 28

/* O[oϐ錾			*/
extern uint8_t pgFlag[];

/* [J֐vg^Cv錾	*/
static void flipItem( uint8_t index );

/*****************************************************************************
*								ݒ
* Fvoid
* ߒlFuint8_t ̉ʔԍ
*****************************************************************************/
uint8_t menu004( void )
{
	uint8_t ky;
	uint8_t index = 0;
	uint8_t screenUpdate = 0;
	TIME tim ,bak;

	/* ݒ						*/
	keysRepetEnable( KEY_UP     ,ON  );
	keysRepetEnable( KEY_DOWN   ,ON  );
	keysRepetEnable( KEY_LEFT   ,OFF );
	keysRepetEnable( KEY_RIGHT  ,OFF );
	keysRepetEnable( KEY_ENTER  ,OFF );
	keysRepetEnable( KEY_CANCEL ,OFF );

	/* 						*/
	LCD_clr();
	drawTitleImage( img016 ,59 ,9 ,255 );		/* "<<ݎݒ>>"			*/
	LCD_drawBMP( img037 ,9 ,45 ,110 ,19 );		/* "EnterFm FI"		*/
												/* "Cancel:@FύX"	*/

	/* ݎ擾					*/
	RTC_get( &tim );
	drawDate( DATE_X ,DATE_Y ,&tim );
	drawTime( TIME_X ,TIME_Y ,&tim );
	flipItem( index );

	/* C[v					*/
	keysClear();
	while ( 1 ) {
		while ( !RTC_TICK_MS10 );			/* 10msecoߑ҂				*/
		RTC_TICK_MS10 = 0;
		wdt_reset();
		keysWatchKey();						/* L[|[O				*/
		ky = keysInkey();					/* L[obt@o			*/

		/* L[				*/
		switch ( ky ) {
			case KEY_ENTER:					/* G^[						*/
				RTC_set( &tim );			/* RTCݒ						*/
				progInitExecFlag();			/* vOsσtOZbg	*/
				drawMessageImage( img031 ,57 ,9 ,10 );	/* "ݒ肵܂"	*/
				return ( 0 );

			case KEY_CANCEL:				/* LZ					*/
				RTC_get( &tim );
				progInitExecFlag();			/* vOsσtOZbg	*/
				drawMessageImage( img027 ,85 ,9 ,10 );	/* "LZ܂"	*/
				return ( 0 );

			case KEY_RIGHT:					/* J[\ړ					*/
				flipItem( index++ );
				if ( index > 5 ) {
					index = 0;
				}
				flipItem( index );
				break;

			case KEY_LEFT:					/* J[\ړ					*/
				flipItem( index-- );
				if ( index == 255 ) {
					index = 5;
				}
				flipItem( index );
				break;

			case KEY_UP:					/* elUP						*/
				screenUpdate = 1;
				memcpy( &bak ,&tim ,sizeof(TIME) );
				date_stepValue( &tim ,index ,0 );
				break;

			case KEY_DOWN:					/* elDOWN						*/
				screenUpdate = 1;
				memcpy( &bak ,&tim ,sizeof(TIME) );
				date_stepValue( &tim ,index ,1 );
				break;

			default:
				break;
		}

		/* \XV			*/
		if ( screenUpdate ) {
			screenUpdate = 0;
			flipItem( index );
			if ( tim.year != bak.year ) drawDateItems( DATE_X ,DATE_Y ,&tim ,0 );
			if ( tim.month != bak.month ) drawDateItems( DATE_X ,DATE_Y ,&tim ,1 );
			if ( tim.day != bak.day ) drawDateItems( DATE_X ,DATE_Y ,&tim ,2 );
			if ( tim.hour != bak.hour ) drawDateItems( TIME_X ,TIME_Y ,&tim ,3 );
			if ( tim.minute != bak.minute ) drawDateItems( TIME_X ,TIME_Y ,&tim ,4 );
			if ( tim.second != bak.second ) drawDateItems( TIME_X ,TIME_Y ,&tim ,5 );
			if ( tim.wday != bak.wday ) drawDateItems( DATE_X ,DATE_Y ,&tim ,6 );
			flipItem( index );
		}
	}

	return ( 0 );
}

/*****************************************************************************
*								J[\]
* Fuint8_t index
* ߒlFvoid
*****************************************************************************/
static void flipItem( uint8_t index )
{
	switch ( index ) {
		case 0:									/* N	*/
			LCD_invertRect( 0 ,18 ,24 ,26 );
			break;

		case 1:									/* 	*/
			LCD_invertRect( 34 ,18 ,45 ,26 );
			break;

		case 2:									/* 	*/
			LCD_invertRect( 54 ,18 ,66 ,26 );
			break;

		case 3:									/* 	*/
			LCD_invertRect( 61 ,28 ,73 ,36 );
			break;

		case 4:									/* 	*/
			LCD_invertRect( 83 ,28 ,95 ,36 );
			break;

		case 5:									/* b	*/
			LCD_invertRect( 105 ,28 ,117 ,36 );
			break;
	}
}

