/*###########################################################################
#                                                                           #
#   		 		         IRwK										#
#                                                                           #
###########################################################################*/
#define __MENU005_C__
#include "project.h"

#define MAIN_IR_BASE_YPOS 11
#define IR_1ST 11
#define IR_2ND 12

/* VXeNbN64̃JEgl1JEgӂ̃ʕb (12.8MHz = 5usec) */
#define USEC_PAR_COUNT ( (uint16_t)( ( 1000000UL / ( (uint32_t)F_CPU / 64UL ) ) ) )

/* VXeNbN64̃JEglʕbɕϊ	*/
#define COUNT2USEC(c) ( (uint16_t)(c) * USEC_PAR_COUNT )

/* [J֐vg^Cv錾	*/
static void testIR( uint8_t index );
static uint8_t ir_Capture( uint8_t index ,IR *ir ,const prog_char *msg );
static uint8_t Infrared_rays_capture( uint8_t index );
static void drawIR( uint8_t y ,uint8_t index ,IR *ir ,uint8_t type ,uint8_t pitch );

/*****************************************************************************
*							ԊOwKC
* Fvoid
* ߒlFuint8_t ̉ʔԍ
*****************************************************************************/
uint8_t menu005( void )
{
	uint8_t ky;
	uint8_t irIndex = 0;
	uint8_t page = 0;
	uint8_t screenUpdate = 1;
	IR ir;

	/* ݒ						*/
	keysRepetEnable( KEY_UP     ,ON  );
	keysRepetEnable( KEY_DOWN   ,ON  );
	keysRepetEnable( KEY_LEFT   ,OFF );
	keysRepetEnable( KEY_RIGHT  ,OFF );
	keysRepetEnable( KEY_ENTER  ,OFF );
	keysRepetEnable( KEY_CANCEL ,OFF );

	/* C[v					*/
	keysClear();
	while ( 1 ) {

		/* 						*/
		if ( screenUpdate ) {
			screenUpdate = 0;
			page = 0;
			LCD_clr();
			drawTitleImage( img017 ,74 ,9 ,255 );			/* "<<ԊOf[^wK>>"				*/
			LCD_drawBMP( img021 ,4 ,45 ,119 ,19 );			/* "EnterFwK@CancelFI       "   */
															/* "FIRI  F  F"	*/

			eep_irRead( irIndex ,&ir );						/* IRf[^\							*/
			drawIR( MAIN_IR_BASE_YPOS ,irIndex ,&ir ,page ,1 );
			keysClear();
		}

		while ( !RTC_TICK_MS10 );			/* 10msecoߑ҂				*/
		RTC_TICK_MS10 = 0;
		wdt_reset();
		keysWatchKey();						/* L[|[O				*/
		ky = keysInkey();					/* L[obt@o			*/
		progTimerPoll();					/* vO|[O			*/

		/* L[				*/
		switch ( ky ) {
			case KEY_ENTER:					/* G^[						*/
				Infrared_rays_capture( irIndex );
				screenUpdate = 1;
				break;

			case KEY_CANCEL:				/* LZ					*/
				return ( 0 );

			case KEY_RIGHT:					/* eXg					*/
				testIR( irIndex );
				keysClear();
				break;

			case KEY_LEFT:					/* y[WύX				*/
				page ^= 1;
				eep_irRead( irIndex ,&ir );	/* IRf[^\					*/
				drawIR( MAIN_IR_BASE_YPOS ,irIndex ,&ir ,page ,1 );
				keysClear();
				break;

			case KEY_UP:					/* IRI						*/
			case KEY_DOWN:					/* IRI						*/
				if ( ky == KEY_UP ) {
					if ( ++irIndex >= 8 ) {
						irIndex = 0;
					}
				} else {
					if ( --irIndex == 255 ) {
						irIndex = 7;
					}
				}
				eep_irRead( irIndex ,&ir );	/* IRf[^\					*/
				drawIR( MAIN_IR_BASE_YPOS ,irIndex ,&ir ,page ,1 );
				keysClear();
				break;

			default:
				break;
		}
	}

	return ( 0 );
}

/*****************************************************************************
*									IReXg
* Fuint8_t index
* ߒlFvoid
*****************************************************************************/
static void testIR( uint8_t index )
{
	IR ir;

	LCD_drawBMP( img023 , 4 ,28 , 20 , 9 );		/* ""				*/
	LCD_invertRect( 1 ,26 ,25 ,38 );
	eep_irRead( index ,&ir );
	ir_output( &ir );
	WAIT_MS( 500 );
	LCD_clearRect( 1 ,26 ,25 ,38 );
}

/*****************************************************************************
*									IRwK
* Fuint8_t index
* ߒlFuint8_t 0:OK !0:NG
*****************************************************************************/
static uint8_t Infrared_rays_capture( uint8_t index )
{
	IR ir1 ,ir2;
	uint8_t ret;

	/* 1ڎ擾					*/
	ret = ir_Capture( index ,&ir1 ,PSTR("1st input") );
	if ( ret != 0 ) {
		return ( 1 );
	}

	/* 2ڎ擾					*/
	ret = ir_Capture( index ,&ir2 ,PSTR("2nd input") );
	if ( ret != 0 ) {
		return ( 2 );
	}

	/* f[^r					*/
	ret = ir_comper( &ir1 ,&ir2 );
	if ( ret == 0 ) {
		ir1.Start_Htime = ( ir1.Start_Htime + ir2.Start_Htime ) / 2;
		ir1.Start_Ltime = ( ir1.Start_Ltime + ir2.Start_Ltime ) / 2;

		ir1.Dat0_Htime = ( ir1.Dat0_Htime + ir2.Dat0_Htime ) / 2;
		ir1.Dat0_Ltime = ( ir1.Dat0_Ltime + ir2.Dat0_Ltime ) / 2;

		ir1.Dat1_Htime = ( ir1.Dat1_Htime + ir2.Dat1_Htime ) / 2;
		ir1.Dat1_Ltime = ( ir1.Dat1_Ltime + ir2.Dat1_Ltime ) / 2;

		ir1.Stop_Htime = ( ir1.Stop_Htime + ir2.Stop_Htime ) / 2;

		eep_irWrite( index ,&ir1 );				/* EEPIR\̏		*/
		drawMessageImage( img030 ,99 ,9 ,20 );	/* "捞݂ɐ܂"		*/
		return ( 0 );
	}

	/* G[\				*/
	drawMessageImage( img029 ,100 ,9 ,20 );		/* "f[^v܂"		*/

	/* 1ڂ2ڂ̃f[^\	*/
	LCD_clr();
	if ( ret < 100 ) {
		drawIR(  0 ,IR_1ST ,&ir1 ,0 ,0 );
		drawIR( 28 ,IR_2ND ,&ir2 ,0 ,0 );
	} else {
		drawIR(  0 ,IR_1ST ,&ir1 ,1 ,0 );
		drawIR( 28 ,IR_2ND ,&ir2 ,1 ,0 );
	}

	/* G^[L[҂				*/
	LCD_Gputs_P( 7 ,57 ,PSTR("Enter   ޻") );
	while ( keysNowKeyNumber() != KEY_ENTER ) wdt_reset();

	return ( 3 );
}

/*****************************************************************************
*								IR擾UI
* Fuint8_t         index
*		IR              *ir
*		const prog_char *msg
* ߒlFuint8_t         0:OK !0:NG
*****************************************************************************/
static uint8_t ir_Capture( uint8_t index ,IR *ir ,const prog_char *msg )
{
	uint8_t ret;
	uint8_t ky;

	/* 					*/
	LCD_clearRect( 0 ,9 ,127 ,63 );
	LCD_drawBMP( img026 ,64 ,55 ,64 ,9 );		/* "CANCELF"			*/

	/* IRԍ]\			*/
	LCD_Gputs_P( 1 ,16 ,PSTR("IR") );
	LCD_Gputchar( 14 ,16 ,'1' + index );
	LCD_invertRect( 0 ,15 ,20 ,23 );

	/* bZ[W\			*/
	LCD_Gputs_P( 32 ,16 ,msg );

	/* ENTERL[҂			*/
	LCD_drawBMP( img024 , 11, 32, 106 ,9 );		/* "EnterL[ĉ" */
	WAIT_MS( 500 );
	keysClear();
	while ( 1 ) {		
		while ( !RTC_TICK_MS10 );				/* 10msecoߑ҂			*/
		RTC_TICK_MS10 = 0;
		wdt_reset();
		keysWatchKey();							/* L[|[O			*/
		ky = keysInkey();						/* L[obt@o		*/
		if ( ky == KEY_CANCEL ) {
			drawMessageImage( img027 ,85 ,9 ,20 );	/* "LZ܂"		*/
			return ( 1 );
		} else if ( ky == KEY_ENTER ) {
			break;
		}
	}

	/* Rf[^҂		*/
	LCD_clearRect( 0 ,32 ,127 ,40 );
	LCD_drawBMP( img025 , 0 , 32 , 128 , 9 );		/* "Ӻ݂݂ĉ"		*/
	if ( ( ret = ir_input( ir ) ) == 0 ) {
		return ( 0 );
	}

	/* 荞݃G[̃bZ[W	*/
	LCD_clearRect( 0 ,32 ,127 ,40 );				/* bZ[W					*/
	if ( ret == 1 ) {								/* [U[LZ				*/
		drawMessageImage( img027 ,85 ,9 ,0 );		/* "LZ܂"				*/

	} else if ( ret == 2 ) {						/* Time out							*/
		LCD_Gputs_P( 31 ,42 ,PSTR("IR time out") );

	} else if ( ret == 3 ) {						/* Bit length error					*/
		LCD_Gputs_P( 16 ,42 ,PSTR("Bit length error") );

	} else if ( ret == 4 ) {						/* Start pulse low time error		*/
		LCD_Gputs_P( 4 ,42 ,PSTR("SL pulse low time NG") );

	} else if ( ret == 5 ) {						/* Start pulse hi time error		*/
		LCD_Gputs_P( 7 ,42 ,PSTR("SH pulse hi time NG") );

	} else if ( ret == 6 ) {						/* Data0 pulse low time error		*/
		LCD_Gputs_P( 4 ,42 ,PSTR("D0 pulse low time NG") );

	} else if ( ret == 7 ) {						/* Data0 pulse hi time error		*/
		LCD_Gputs_P( 7 ,42 ,PSTR("D0 pulse hi time NG") );

	} else if ( ret == 8 ) {						/* Data1 pulse low time error		*/
		LCD_Gputs_P( 4 ,42 ,PSTR("D1 pulse low time NG") );

	} else if ( ret == 9 ) {						/* Data1 pulse hi time error		*/
		LCD_Gputs_P( 7 ,42 ,PSTR("D1 pulse hi time NG") );

	} else if ( ret == 10 ) {						/* Stop pulse hi time error			*/
		LCD_Gputs_P( 7 ,42 ,PSTR("EH pulse hi time NG") );

	} else {
		LCD_Gputs_P( 19 ,42 ,PSTR("Uncertain error") );

	}

	if ( ret != 1 ) {
		drawMessageImage( img028 ,100 ,9 ,0 );		/* "捞݂Ɏs܂"			*/
	}

	LCD_clearRect( 0 ,55 ,127 ,63 );
	LCD_drawBMP( img024 , 11, 55, 106 ,9 );			/* "EnterL[ĉ" 		*/
	while ( keysNowKeyNumber() != KEY_ENTER ) wdt_reset();

	return ( ret );
}

/*****************************************************************************
*									IR\(32line)
* Fuint8_t y     \JnYW
*		uint8_t index CfbNXԍ  0 ` 7 : IRԍ
*								       11      : 1st
*								       12      : 2nd
*		IR      *ir   IRf[^\
*		uint8_t type  0:IRpX
*					  1:IRoCg
*		uint8_t pitch ssb`
* ߒlFvoid
*****************************************************************************/
static void drawIR( uint8_t y ,uint8_t index ,IR *ir ,uint8_t type ,uint8_t pitch )
{
	char buf[20];
	uint8_t by = y;

	/* ʕ`̈NA			*/
	LCD_clearRect( 0 ,by ,127 ,by + 31 );

	/* IRԍ]\				*/
	if ( index <= 7 ) {
		LCD_Gputs_P( 1 ,by + pitch ,PSTR("IR") );
		LCD_Gputchar( 14 ,by + pitch ,'1' + index );
		LCD_invertRect( 0 ,by ,20 ,by + pitch + 7 );

	} else if ( index == 11 ) {
		LCD_Gputs_P( 1 ,by + pitch ,PSTR("1st") );

	} else {
		LCD_Gputs_P( 1 ,by + pitch ,PSTR("2nd") );
	}

	if ( type == 0 ) {

		by += pitch;

		/* X^[gpX\		*/
		strcpy_P( buf ,PSTR("SH") );
		Uint16ToString( &buf[2] ,COUNT2USEC(ir->Start_Htime) ,4 ,' ' );
		strcpy_P( &buf[6] ,PSTR("us") );
		LCD_Gputs( 27 ,by ,buf );

		strcpy_P( buf ,PSTR("SL") );
		Uint16ToString( &buf[2] ,COUNT2USEC(ir->Start_Ltime) ,4 ,' ' );
		strcpy_P( &buf[6] ,PSTR("us") );
		LCD_Gputs( 80 ,by ,buf );

		by += ( 7 + pitch );

		/* f[^pXiOj\	*/
		strcpy_P( buf ,PSTR("0H") );
		Uint16ToString( &buf[2] ,COUNT2USEC(ir->Dat0_Htime) ,4 ,' ' );
		strcpy_P( &buf[6] ,PSTR("us") );
		LCD_Gputs( 27 ,by ,buf );

		strcpy_P( buf ,PSTR("0L") );
		Uint16ToString( &buf[2] ,COUNT2USEC(ir->Dat0_Ltime) ,4 ,' ' );
		strcpy_P( &buf[6] ,PSTR("us") );
		LCD_Gputs( 80 ,by ,buf );

		by += ( 7 + pitch );

		/* f[^pXiPj\	*/
		strcpy_P( buf ,PSTR("1H") );
		Uint16ToString( &buf[2] ,COUNT2USEC(ir->Dat1_Htime) ,4 ,' ' );
		strcpy_P( &buf[6] ,PSTR("us") );
		LCD_Gputs( 27 ,by ,buf );

		strcpy_P( buf ,PSTR("1L") );
		Uint16ToString( &buf[2] ,COUNT2USEC(ir->Dat1_Ltime) ,4 ,' ' );
		strcpy_P( &buf[6] ,PSTR("us") );
		LCD_Gputs( 80 ,by ,buf );

		by += ( 7 + pitch );

		/* XgbvpX			*/
		strcpy_P( buf ,PSTR("EH") );
		Uint16ToString( &buf[2] ,COUNT2USEC(ir->Stop_Htime) ,4 ,' ' );
		strcpy_P( &buf[6] ,PSTR("us") );
		LCD_Gputs( 27 ,by ,buf );

		/* rbg						*/
		strcpy_P( buf ,PSTR("bits") );
		Uint16ToString( &buf[4] ,ir->bitLength ,4 ,' ' );
		LCD_Gputs( 80 ,by ,buf );

	} else {
		/* 16iŃoCgf[^\	*/
		uint8_t x = 26;
		uint8_t bitPoint = 0;
		for ( uint8_t i = 0 ;i < 31 ;i++ ) {
			if ( ( i != 0 ) && ( ( i % 8 ) == 0 ) ) {
				x = 26;
				by += ( 7 + pitch );
			}

			bitPoint = i * 8;
			if ( ( bitPoint >= ir->bitLength ) || ( ir->bitLength == 0 ) ) {
				strcpy_P( buf ,PSTR("--") );
			} else {
				Uint16ToHex( buf ,ir->datas[i] ,2 ,'0' );
			}

			LCD_Gputs( x ,by ,buf );

			bitPoint += 8;
			x += 13;
		}
	}
}
