/*###############################################################################################
#                                                                          					    #
#                               J_[֘AW[    	          					    #
#                                                                          					    #
# CEX -> OSIϊASYQlURL											#
# http://delfusa.main.jp/delfusafloor/archive/www.nifty.ne.jp_forum_fdelphi/samples/00850.html	#
#                                                                                               #
###############################################################################################*/
#define __DATE_C__
#include "project.h"

/* [Jϐ`				*/
volatile static uint8_t ms10Count = 0;			/* 1b𓾂ׂ̃JE^				*/
volatile static uint8_t reqGetRtcFlag = 0;		/* RTC̒l擾vtO			*/
volatile static uint32_t rtcCount = 0L;			/* RTCJE^							*/
volatile static uint32_t rtcGetCount = 0L;		/* RTCJE^擾l					*/
static uint32_t startMJD = 0;					/* ǗJnN̏CEX		*/

/*****************************************************************************
*							RTC荞(timer2 / 10msec)
*****************************************************************************/
ISR( TIMER2_COMPA_vect )
{
	/* 1bJEg						*/
	if ( ++ms10Count >= 100 ) {
		ms10Count = 0;
		rtcCount++;
	}

	/* 擾NGXg			*/
	if ( reqGetRtcFlag ) {
		rtcGetCount = rtcCount;
		reqGetRtcFlag = 0;
	}

	RTC_TICK_MS10 = 1;

	/* 񊄂荞݃^C~O			*/
	OCR2A += MS10COUNT;
}

/*****************************************************************************
*								RTC
* Fvoid
* ߒlFvoid
*****************************************************************************/
void RTC_init( void )
{
	/* Timer2 ~				*/
	TCCR2A = 0;
	TCCR2B = 0;

	/* eϐ				*/
	RTC_TICK_MS10 = 0;				/* 10mseco߃tO						*/
	ms10Count = 0;					/* 1b𓾂ׂ̃JE^				*/
	reqGetRtcFlag = 0;				/* RTC̒l擾vtO			*/
	rtcCount = 0L;					/* RTCJE^							*/
	rtcGetCount = 0L;				/* RTCJE^擾l					*/
	startMJD = 0;					/* ǗJnN̏CEX		*/

	/* ǗJnN̏CEXvZ	*/
	startMJD = date_greg2mjd( START_YEAR ,START_MONTH ,START_DAY );

	/* ݒ							*/
	TIME t;
	t.year = START_YEAR;
	t.month = START_MONTH;
	t.day = START_DAY;
	t.hour = 0;
	t.minute = 0;
	t.second = 0;
	RTC_set( &t );
}

/*****************************************************************************
*							VXeݒ
* FTIME *t 擾\(j̒l͖)
* ߒlFvoid
*****************************************************************************/
void RTC_set( TIME *t )
{
	/* Timer2 ~				*/
	TCCR2A = 0;
	TCCR2B = 0;
	OCR2A = MS10COUNT;
	TCNT2 = 0;

	/* RTCϐݒ				*/
	ms10Count = 0;
	reqGetRtcFlag = 0;

	/* RTCJE^ݒ			*/
	rtcCount = RTC_convSerial( t );

	/* Timer2 荞݊Jn		*/
	TCCR2B = _BV(CS22) | _BV(CS21) | _BV(CS20);		/* F_CPU / 1024			*/
	TIMSK2 = _BV(OCIE2A);
}

/*****************************************************************************
*							VXe擾
* FTIME *t 擾\
* ߒlFvoid
*****************************************************************************/
void RTC_get( TIME *t )
{
	uint32_t serial = RTC_getSerial();
	RTC_convTime( serial ,t );
}

/*****************************************************************************
*						VAlTIME\̂ɕϊ
* Fuint32_t serial VAl
*		TIME     *t     擾\
* ߒlFvoid
*****************************************************************************/
void RTC_convTime( uint32_t serial ,TIME *t )
{
	uint32_t mjd;
	uint32_t tim;

	mjd = ( serial / 86400L ) + startMJD;
	tim = serial % 86400L;

	/* t擾						*/
	date_mjd2greg( mjd ,&t->year ,&t->month ,&t->day ,&t->wday );

	/* 擾						*/
	t->hour = (uint8_t)( tim / 3600L );
	t->minute = (uint8_t)( ( tim % 3600L ) / 60L );
	t->second = (uint8_t)( tim % 60L );
}

/*****************************************************************************
*					TIME\̂VAlɕϊ
* FTIME *t     擾\
* ߒlFuint32_t    VAl
*****************************************************************************/
uint32_t RTC_convSerial( TIME *t )
{
	uint32_t serial;
	serial = ( date_greg2mjd( t->year ,t->month ,t->day ) - startMJD ) * 86400L;					/* t	*/
	serial += ( (uint32_t)t->hour * 3600L ) + ( (uint32_t)t->minute * 60L ) + (uint32_t)t->second;	/* 	*/
	return ( serial );
}

/*****************************************************************************
*						VXẽVAl擾
* Fvoid
* ߒlFuint32_t
*****************************************************************************/
uint32_t RTC_getSerial( void )
{
	reqGetRtcFlag = 1;
	while ( reqGetRtcFlag );
	return ( rtcGetCount );
}

/*****************************************************************************
*	OSICEX(1858N1117N_Ƃʓjɕϊ
* Fuint16_t year  
*       uint8_t  month 
*		uint8_t  day   
* ߒlFuint32_t       CEX
*****************************************************************************/
uint32_t date_greg2mjd( uint16_t year ,uint8_t month ,uint8_t day )
{
	uint32_t a;
	uint16_t b;

	/* t[Q̌ɂMJĎvZ		*/
	if ( month <= 2 ) {		/* 12͑ONƂČvZ	*/
		month += 12;
		year--;
	}

	a = ( 36525L * (uint32_t)year ) / 100L;
	b = ( year / 400 ) + ( ( 3059 * ( (uint16_t)month - 2 ) ) / 100 ) + (uint16_t)day - ( year / 100 );

	return ( a + (uint32_t)b - 678912L );
}

/*****************************************************************************
*	CEX(1858N1117N_ƂʓjOSIɕϊ
* Fuint32_t mjd    CEX
*       uint16_t *year  i[ϐւ̃|C^
*       uint8_t  *month i[ϐւ̃|C^
*		uint8_t  *day   i[ϐւ̃|C^
*		uint8_t  *wday  j(0: ` 6:y)i[ϐւ̃|C^
* ߒlFvoid
*****************************************************************************/
void date_mjd2greg( uint32_t mjd ,uint16_t *year ,uint8_t *month ,uint8_t *day ,uint8_t *wday )
{
	uint32_t mjd1 ,mjd2;
	uint16_t a;
	uint16_t md;
	uint16_t y ,m ,d;

	/* ߂lNA					*/
	*year = 0;
	*month = 0;
	*day = 0;

	/* jvZ						*/
	*wday = ( mjd - 4L ) % 7;

	/* NvZ						*/
	mjd1 = mjd + 678882UL;
	y = (uint16_t)( mjd1 / 365L ) - 2;
	do {
		a = ( y / 4 ) + ( y / 400 ) + 306 - ( y / 100 );
		mjd2 = ( (uint32_t)y * 365L ) + (uint32_t)a;
		y--;
	} while ( mjd2 >= mjd1 );
	y += 2;

	/* vZ / vZ				*/
	d = (uint16_t)( mjd - date_greg2mjd( (uint16_t)y ,1 ,1 ) ) + 1;
	for ( m = 1 ;m <= 12 ;m++ ) {
		md = date_daysOfMonth( y ,m );
		if ( d <= md ) {
			*year = y;
			*month = (uint8_t)m;
			*day = (uint8_t)d;
			break;
		}
		d -= md;
	}
}

/*****************************************************************************
*						w̔NE̓擾
*	Fuint16_t year  N
*		  uint8_t  month 
*	ߒlFuint8_t     	  28`31
*****************************************************************************/
uint8_t date_daysOfMonth( uint16_t year ,uint8_t month )
{
	static const prog_int8_t dfm[] = { 31 ,28 ,31 ,30 ,31 ,30 ,31 ,31 ,30 ,31 ,30 ,31 };

	if ( ( month == 2 ) && IS_LEAP_YEAR( year ) ) {
		return ( 29 );
	}

	return ( pgm_read_byte( &dfm[ month - 1 ] ) );
}


/*****************************************************************************
*					TIME\̂̊eo1Xebv
* FTIME *t
*		uint8_t index 0:N / 1: / 2: / 3: / 4: / 5:b
*		uint8_t dir   0:CN[h  !0:fNg
* ߒlFvoid
*****************************************************************************/
void date_stepValue( TIME *t ,uint8_t index ,uint8_t dir )
{
	uint8_t d;
	uint32_t mjd;

	switch ( index ) {
		case 0:						/* N					*/
			if ( dir == 0 ) {
				if ( ++t->year > 2099 ) {
					t->year = 2000;
				}
			} else {
				if ( --t->year < 2000 ) {
					t->year = 2099;
				}
			}
			break;

		case 1:						/* 					*/
			if ( dir == 0 ) {
				if ( ++t->month > 12 ) {
					t->month = 1;
				}
			} else {
				if ( --t->month == 0 ) {
					t->month = 12;
				}
			}
			break;

		case 2:						/* 					*/
			d = date_daysOfMonth( t->year ,t->month );
			if ( dir == 0 ) {
				if ( ++t->day > d ) {
					t->day = 1;
				}
			} else {
				if ( --t->day == 0 ) {
					t->day = d;
				}
			}
			break;

		case 3:						/* 					*/
			if ( dir == 0 ) {
				if ( ++t->hour > 23 ) {
					t->hour = 0;
				}
			} else {
				if ( --t->hour == 255 ) {
					t->hour = 23;
				}
			}
			break;

		case 4:						/* 					*/
			if ( dir == 0 ) {
				if ( ++t->minute > 59 ) {
					t->minute = 0;
				}
			} else {
				if ( --t->minute == 255 ) {
					t->minute = 59;
				}
			}
			break;

		default:					/* b					*/
			if ( dir == 0 ) {
				if ( ++t->second > 59 ) {
					t->second = 0;
				}
			} else {
				if ( --t->second == 255 ) {
					t->second = 59;
				}
			}
			break;
	}

	/* ̐			*/
	d = date_daysOfMonth( t->year ,t->month );
	if ( t->day > d ) {
		t->day = d;
	}

	/* jvZ				*/
	mjd = date_greg2mjd( t->year ,t->month ,t->day );
	t->wday = (uint8_t)( ( mjd - 4L ) % 7 );
}
