/*###########################################################################
#                                                                           #
#      			             `֘A										#
#                                                                           #
###########################################################################*/
#define __DRAW_C__
#include "project.h"

/*****************************************************************************
*						t "yyyyNmmdd" \
* Fuint8_t x
*		uint8_t y
*		TIME *t
* ߒlFvoid
*****************************************************************************/
void drawDate( uint8_t x ,uint8_t y ,TIME *t )
{
	drawDateItems( x ,y ,t ,0 );				/* Nl		*/
	LCD_drawBMP( img004 ,x + 24 ,y ,9 ,9 );		/* "N"			*/

	drawDateItems( x ,y ,t ,1 );				/* l		*/
	LCD_drawBMP( img005 ,x + 45 ,y ,8 ,9 );		/* ""	*/

	drawDateItems( x ,y ,t ,2 );				/* l		*/
	LCD_drawBMP( img006 ,x + 66 ,y ,8 ,9 );		/* ""	*/

	/* j\		*/
	LCD_drawBMP( img012 ,x + 80 ,y ,3 ,9 );		/* "y"			*/
	drawDateItems( x ,y ,t ,6 );				/* jl		*/
	LCD_drawBMP( img011 ,x + 94 ,y ,18 ,9 );	/* "j"		*/
	LCD_drawBMP( img013 ,x + 114 ,y ,3 ,9 );	/* "z"			*/
}

/*****************************************************************************
*						 "hhmmssb" \
* Fuint8_t x
*		uint8_t y
*		TIME *t
* ߒlFvoid
*****************************************************************************/
void drawTime( uint8_t x ,uint8_t y ,TIME *t )
{
	drawDateItems( x ,y ,t ,3 );				/* l		*/
	LCD_drawBMP( img007 ,x + 12 ,y ,9 ,9 );		/* ""	*/

	drawDateItems( x ,y ,t ,4 );				/* l		*/
	LCD_drawBMP( img008 ,x + 34 ,y ,9 ,9 );		/* ""	*/

	drawDateItems( x ,y ,t ,5 );				/* bl		*/
	LCD_drawBMP( img009 ,x + 56 ,y ,9 ,9 );		/* "b"	*/
}

/*****************************************************************************
*						TIME\̂̊eACe̒l\
* Fuint8_t x
*		uint8_t y
*		TIME *t
*		uint8_t index 0:N 1: 2: 3: 4: 5:b 6:j
* ߒlFvoid
*****************************************************************************/
void drawDateItems( uint8_t x ,uint8_t y ,TIME *t ,uint8_t index )
{
	char buf[6];

	switch ( index ) {
		case 0:					/* N			*/
			Uint16ToString( buf ,t->year ,4 ,' ' );
			LCD_Gputs( x ,y + 1 ,buf );
			break;

		case 1:					/* 			*/
			Uint16ToString( buf ,t->month ,2 ,' ' );
			LCD_Gputs( x + 34 ,y + 1 ,buf );
			break;

		case 2:					/* 			*/
			Uint16ToString( buf ,t->day ,2 ,' ' );
			LCD_Gputs( x + 54 ,y + 1 ,buf );
			break;

		case 3:					/* 			*/
			Uint16ToString( buf ,t->hour ,2 ,'0' );
			LCD_Gputs( x ,y + 1 ,buf );
			break;

		case 4:					/* 			*/
			Uint16ToString( buf ,t->minute ,2 ,'0' );
			LCD_Gputs( x + 22 ,y + 1 ,buf );
			break;

		case 5:					/* b			*/
			Uint16ToString( buf ,t->second ,2 ,'0' );
			LCD_Gputs( x + 44 ,y + 1 ,buf );
			break;

		default:				/* j			*/
			LCD_drawBMP( img010[t->wday] ,x + 84 ,y ,9 ,9 );
			break;
	}
}

/*****************************************************************************
*							bZ[WC[W\
* Fconst prog_uint8_t *img   C[Wf[^
*		uint8_t            width  C[W
*		uint8_t            height C[W
*		uint8_t            t      ҂(100msecP)
* ߒlFvoid
*****************************************************************************/
void drawMessageImage( const prog_uint8_t *img ,uint8_t width ,uint8_t height ,uint8_t t )
{
	uint8_t x1 ,y1;
	uint8_t x2 ,y2;

	/* `WvZ					*/
	x1 = 64 - ( width / 2 );
	y1 = 32 - ( height / 2 );
	x2 = x1 + width - 1;
	y2 = y1 + height - 1;

	/* g\						*/
	LCD_clearRect( x1 - 5 ,y1 - 5 ,x2 + 5 ,y2 + 5 );
	LCD_drawRect( x1 - 3 ,y1 - 3 ,x2 + 3 ,y2 + 3 );
	LCD_drawRect( x1 - 2 ,y1 - 2 ,x2 + 2 ,y2 + 2 );

	/* bZ[WC[WuN	*/
	for ( uint8_t i = 0 ;i < 3 ;i++ ) {
		wdt_reset();
		LCD_drawBMP( img ,x1 ,y1 ,width ,height );
		WAIT_MS( 100 );
		LCD_clearRect( x1 ,y1 ,x2 ,y2 );
		WAIT_MS( 100 );
	}

	/* ҂						*/
	LCD_drawBMP( img ,x1 ,y1 ,width ,height );
	if ( t ) {
		LCD_drawBMP( img ,x1 ,y1 ,width ,height );
		while ( t-- ) {
			wdt_reset();
			WAIT_MS( 100 );
		}
		wdt_reset();
	}
}

/*****************************************************************************
*					"<<" ">>" ň͂񂾉ʍŏ㕔ɕ\
* Fconst prog_uint8_t *img \C[W
*		uint8_t width			
*		uint8_t height			c
*		uint8_t pos				XW(255:)
* ߒlFvoid
*****************************************************************************/
void drawTitleImage( const prog_uint8_t *img ,uint8_t width ,uint8_t height ,uint8_t pos )
{
	uint8_t x;

	/* XWvZ				*/
	if ( pos == 255 ) {
		x = 64 - ( ( width + 24 ) / 2 );
	} else {
		x = pos;
	}

	LCD_drawBMP( img019 , x , 0 , 11 , 9 );		/* "<<"			*/
	x += 12;

	LCD_drawBMP( img ,x ,0 ,width ,height );	/* C[W\	*/
	x += ( width + 1 );

	LCD_drawBMP( img020 ,x , 0 , 11 , 9 );		/* ">>"			*/
}
