/*###########################################################################
#                                                                           #
#   		 		         Cj[W[						#
#                                                                           #
###########################################################################*/
#define __MENU002_C__
#include "project.h"

/* [J֐vg^Cv錾	*/
static void initScreen( uint8_t index );
static void flipItem( uint8_t index );

/*****************************************************************************
*								Cj[
* Fvoid
* ߒlFuint8_t ̉ʔԍ
*****************************************************************************/
uint8_t menu002( void )
{
	uint8_t index = 0;
	uint8_t ky;

	/* ݒ						*/
	keysRepetEnable( KEY_UP     ,OFF );
	keysRepetEnable( KEY_DOWN   ,OFF );
	keysRepetEnable( KEY_LEFT   ,OFF );
	keysRepetEnable( KEY_RIGHT  ,OFF );
	keysRepetEnable( KEY_ENTER  ,OFF );
	keysRepetEnable( KEY_CANCEL ,OFF );
	initScreen( index );

	/* C[v					*/
	keysClear();
	while ( 1 ) {
		while ( !RTC_TICK_MS10 );			/* 10msecoߑ҂				*/
		RTC_TICK_MS10 = 0;
		wdt_reset();
		keysWatchKey();						/* L[|[O				*/
		ky = keysInkey();					/* L[obt@o			*/
		progTimerPoll();					/* vO|[O			*/

		/* L[				*/
		switch ( ky ) {
			case KEY_ENTER:
				return ( index + 2 );

			case KEY_CANCEL:
				return ( 0 );

			case KEY_UP:
				flipItem( index-- );
				if ( index == 255 ) {
					index = 2;
				}
				flipItem( index );
				break;

			case KEY_DOWN:
				flipItem( index++ );
				if ( index > 2 ) {
					index = 0;
				}
				flipItem( index );
				break;

			default:
				break;
		}
	}

	return ( 0 );
}

/*****************************************************************************
*								ʕ\
* Fuint8_t index
* ߒlFvoid
*****************************************************************************/
static void initScreen( uint8_t index )
{
	LCD_clr();
	drawTitleImage( img018 ,57 ,9 ,255 );		/* ^Cg`				*/

	LCD_drawBMP( img015 ,33 ,13 ,61 ,9 );		/* "vOݒ"			*/
	LCD_drawBMP( img016 ,34 ,23 ,59 ,9 );		/* "ݎݒ"			*/
	LCD_drawBMP( img017 ,27 ,33 ,74 ,9 );		/* "ԊOf[^wK"		*/

	LCD_drawBMP( img033 ,12 ,45 ,103 ,19 );		/* "Enter:s  :I"	*/
												/* "Cancel:		 "	*/
	flipItem( index );
}

/*****************************************************************************
*								J[\]
* Fuint8_t index
* ߒlFvoid
*****************************************************************************/
static void flipItem( uint8_t index )
{
	uint8_t y1 = 12 + ( index * 10 );
	uint8_t y2 = y1 + 10;
	LCD_invertRect( 16 ,y1 ,112, y2 );
}
