/*############################################################################
##                                                                          ##
##                     LCDW[ SG12864A 䃂W[				##
##                                                                          ##
############################################################################*/
#ifndef __SG12864A_H__
#define __SG12864A_H__

#include <avr/io.h>
#include <avr/pgmspace.h>

/* gp@\I	0:gp !0:gp	*/
#define LCD_USE_CIRCLE 0						/* ~`					*/
#define LCD_USE_RECT 1							/* lp``				*/

/*	֐vg^Cv錾			*/
void LCD_init( void );
void LCD_on( void );
void LCD_off( void );
void LCD_clr( void );
void LCD_pixelOn( uint8_t x, uint8_t y );
void LCD_pixelOff(uint8_t x, uint8_t y);
void LCD_invertPixel( uint8_t x ,uint8_t y );
void LCD_putchar( uint8_t page ,uint8_t x ,uint8_t c );
void LCD_puts( uint8_t page ,uint8_t x ,const char *str );
void LCD_puts_P( uint8_t page ,uint8_t x ,const prog_char *str );
void LCD_Gputchar( uint8_t x ,uint8_t y ,char c );
void LCD_Gputs( uint8_t x ,uint8_t y ,const char *str );
void LCD_Gputs_P( uint8_t x ,uint8_t y ,const prog_char *str );
void LCD_drawLine( uint8_t x0 ,uint8_t y0 ,uint8_t x1 ,uint8_t y1 );
void LCD_clearLine(uint8_t x0, uint8_t y0, uint8_t x1, uint8_t y1);
void LCD_invertLine( uint8_t x0 ,uint8_t y0 ,uint8_t x1 ,uint8_t y1 );
void LCD_drawRect( uint8_t x1 ,uint8_t y1 ,uint8_t x2 ,uint8_t y2 );
void LCD_fillRect( uint8_t x1 ,uint8_t y1 ,uint8_t x2 ,uint8_t y2 );
void LCD_clearRect( uint8_t x1 ,uint8_t y1 ,uint8_t x2 ,uint8_t y2 );
void LCD_invertRect( uint8_t x1 ,uint8_t y1 ,uint8_t x2 ,uint8_t y2 );
void LCD_drawCirc( uint8_t x1 ,uint8_t y1 ,uint8_t radius );
void LCD_fillCirc(uint8_t x1, uint8_t y1, uint8_t radius);
void LCD_clearCirc(uint8_t x1, uint8_t y1, uint8_t radius);
void LCD_invertCirc(uint8_t x1, uint8_t y1, uint8_t radius);
void LCD_drawFullBMP( const prog_uint8_t *bitmap );
void LCD_drawBMP( const prog_uint8_t *bitmap ,uint8_t x ,uint8_t y ,uint8_t width ,uint8_t height );

#endif
